//The station object definition
function Station(rank, name, addr1, addr2)
{
    this.rank = rank;
    this.name = name;
    this.addr1 = addr1;
    this.addr2 = addr2;
    this.prices = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]]; //2D array: [grades][digits]
    this.timestamps = [100,100,100,100];
	this.hours = [0, 0, 0, 0];
    this.colors = [gray, gray, gray, gray];
    this.nameIndex = 0;
    this.logo = getLogo(this.name);
    
    function display()
    {        
        $('rank').innerHTML = this.rank;
    
        var q = this.addr1.replace(/ /g,"+") + "+" + this.addr2.replace(/ /g,"+");
        
		//trim station info to fit
		var overflowDIV = document.getElementById('overflowDIV');
		
		overflowDIV.innerText = this.name;
		while(overflowDIV.offsetWidth > 120)
		{
			this.name = this.name.substring(0,this.name.length - 4) + "...";
			overflowDIV.innerText = this.name;
		}
		
		overflowDIV.innerText = this.addr1;
		while(overflowDIV.offsetWidth > 120)
		{
			this.addr1 = this.addr1.substring(0,this.addr1.length - 4) + "...";
			overflowDIV.innerText = this.addr1;
		}
		
		overflowDIV.innerText = this.addr2;
		while(overflowDIV.offsetWidth > 120)
		{
			this.addr2 = this.addr2.substring(0,this.addr2.length - 4) + "...";
			overflowDIV.innerText = this.addr2;
		}
				
        if(this.name == "No results found.")
        {
        	this.logo = "images/stations/error.png";
        	$('address').innerHTML = "<a href=\"javascript:showbackside();\"><b>"+ this.name +"</b><br>"+ this.addr1 +"<br>"+ this.addr2 +"</a>";
        }
        else
        	$('address').innerHTML = "<a href=\"javascript:widget.openURL('http://maps.google.com/maps?q="+q+"')\"><b>"+ this.name +"</b><br>"+ this.addr1 +"<br>"+ this.addr2 +"</a>";
        
        $('logo').src = this.logo;
		
        spinPrice();
        setTimeout("stationList[rankShown-1].displayPrices();", 200);
    }
    
    function displayPrices()
    {
        for(var i = 0; i < 4; i++)
            this.displayPriceForGrade(gradeList[i]);
    }
    
    function setPriceForGrade(grade, price, hours)
    {
        for(var i = 0; i < 4; i++)
        {   
            if(grade == gradeList[i])
            {            
                //store the relevant information
                this.prices[i][0] = price[0];
                this.prices[i][1] = price[1];
                this.prices[i][2] = price[2];
                this.timestamps[i] = this.createTimestamp(hours);
				this.hours[i] = hours;
                this.colors[i] = this.calculateColor(hours);
                
                //display the price if we are currently viewing this station
                if(this.rank == rankShown) {
                    this.displayPriceForGrade(grade);
                }
            }
        }
    }
    
    function priceForGrade(grade)
    {
        for(var i = 0; i < 4; i++)
        {   
            if(grade == gradeList[i])
            {            
                //store the relevant information
                var hs = this.prices[i][0];
                var ts = this.prices[i][1];
                var os = this.prices[i][2];
                
      			return hs + "." + ts + "" + os;
            }
        }
    }
 
    function displayPriceForGrade(grade)
    {
        for(var i = 0; i < 4; i++)
        {   
            if(grade == gradeList[i])
            {   
                var gradeDIV = $(gradeList[i]);
                for(var j = 0; j < 3; j++)
                {
					if(this.rank == rankShown)
					{
						clearTimeout(gradeTimers[i][j]);
	                    gradeTimers[i][j] = setTimeout(stopDigit, j*100, gradeDIV, j+1, this.prices[i][j], this.colors[i], this.timestamps[i]);
					} else
						stopDigit(gradeDIV, j+1, this.prices[i][j], this.colors[i], this.timestamps[i]);
                }

				getSubelementById(gradeDIV, 'timestamp').title = this.timestamps[i];
				getSubelementById(gradeDIV, 'digit4').title = timestamp;
				if(this.hours[i] < 0)
					getSubelementById(gradeDIV, 'timestamp').innerText = " no price data";
				else
					getSubelementById(gradeDIV, 'timestamp').innerText = this.hours[i] + " hour" + ((this.hours[i] == 1) ? " ago" : "s ago");
            }
        }
    }

	function stopDigit(div, cell, digit, color, timestamp)
	{
		//display the digit, color, and timestamp
		// if(digit == 'n' || digit == 's' || digit == 'p')
		// {
		// 	getSubelementById(div, 'cell' + cell).style.background = "none";
		// 	getSubelementById(div, 'digit' + cell).style.display = "none";
		// } else {
		// 	getSubelementById(div, 'cell' + cell).style.background = ($("colorbox").checked) ? color : yellow;
		// 	getSubelementById(div, 'digit' + cell).style.display = "inline";
		// }
		
		if(cell == 3)
			getSubelementById(div, 'cell4').style.background = ($("colorbox").checked) ? color : yellow;
		
		getSubelementById(div, 'cell' + cell).style.background = ($("colorbox").checked) ? color : yellow;	
		getSubelementById(div, 'digit' + cell).src = 'images/numbers/' + digit + '.png';
		getSubelementById(div, 'digit' + cell).title = timestamp;
		
	}

    function calculateColor(hours)
    {
    	if(hours <   0) return gray;
        if(hours <= 24) return green;
        if(hours <= 48) return yellow;
        if(hours <= 72) return orange;
        
        return red;
    }
    
    function createTimestamp(hours)
    {
    	if(hours < 0) return "No price available."
    
        var h = hours%24;
        var d = (hours - h)/24;
        
        var days = (d > 0) ? (d + ((d > 1) ? " days" : " day")) : "";
        hours =  (h > 0) ? (h + ((h > 1) ? " hours" : " hour")) : "";
        var and = (d > 0 && h > 0) ? " and " : "";
        var minutes = (d == 0 && h == 0) ? "less than 1 hour" : "";
        return "Last updated " + days + and + hours + minutes + " ago.";
    }
    
    function getLogo(name)
    {
    	var logo = "images/stations/unbranded.png";
    	var names = name.toLowerCase().replace(" ", "|");
    	
    	var logos = widget.system("ls ~/Library/Widgets/Gas.wdgt/images/stations | grep -E '" + names + "'", null).outputString;
    	if(logos) logos = logos.match(/\S+/g);
    	if(logos) logo = "images/stations/" + logos[0];
    	
    	return logo;
    }
 
    this.display = display;
    this.displayPrices = displayPrices;
    this.setPriceForGrade = setPriceForGrade;
    this.displayPriceForGrade = displayPriceForGrade;
    this.calculateColor = calculateColor;
    this.createTimestamp = createTimestamp;
    this.priceForGrade = priceForGrade;
    this.getLogo = getLogo;
}